# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, Dict, Optional

from truefoundry.ml._autogen.client.models.chat_prompt_manifest_messages_inner import (
    ChatPromptManifestMessagesInner,
)
from truefoundry.ml._autogen.client.models.model_configuration import ModelConfiguration
from truefoundry.pydantic_v1 import (
    BaseModel,
    Field,
    StrictStr,
    conint,
    conlist,
    constr,
    validator,
)


class ChatPromptManifest(BaseModel):
    """
    Chat Prompt manifest.  # noqa: E501
    """

    name: Optional[constr(strict=True, max_length=256)] = Field(
        default=None, description="Name of the entity"
    )
    description: Optional[constr(strict=True, max_length=512)] = None
    metadata: Dict[str, Any] = Field(
        default=...,
        description='Key value metadata. Should be valid JSON. For e.g. `{"business-unit": "sales", "quality": "good", "rating": 4.5}`',
    )
    version_alias: Optional[constr(strict=True, max_length=128)] = Field(
        default=None,
        description="Version alias is alternate, ideally human readable, version string to reference an artifact version. It should start with `v` followed by alphanumeric and it can include `.` and `-` in between (e.g. `v1.0.0`, `v1-prod`, `v3-dev`, etc)",
    )
    ml_repo: Optional[constr(strict=True)] = Field(
        default=None, description="Name of the ML Repo"
    )
    version: Optional[conint(strict=True, ge=1)] = Field(
        default=None, description="Version of the entity"
    )
    type: Optional[StrictStr] = "chat_prompt"
    messages: conlist(ChatPromptManifestMessagesInner) = Field(
        default=...,
        description="List of messages in the chat conversation, must be non-empty",
    )
    variables: Optional[Dict[str, StrictStr]] = Field(
        default=None,
        description="Variables referenced in messages and that can be replaced when running generation",
    )
    model_configuration: ModelConfiguration = Field(...)
    __properties = [
        "name",
        "description",
        "metadata",
        "version_alias",
        "ml_repo",
        "version",
        "type",
        "messages",
        "variables",
        "model_configuration",
    ]

    @validator("name")
    def name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Za-z0-9_\-]+$", value):
            raise ValueError(
                r"must validate the regular expression /^[A-Za-z0-9_\-]+$/"
            )
        return value

    @validator("version_alias")
    def version_alias_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^v[a-zA-Z0-9.-]*([a-zA-Z0-9]+)$", value):
            raise ValueError(
                r"must validate the regular expression /^v[a-zA-Z0-9.-]*([a-zA-Z0-9]+)$/"
            )
        return value

    @validator("ml_repo")
    def ml_repo_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[a-zA-Z][a-zA-Z0-9\-]{1,98}[a-zA-Z0-9]$", value):
            raise ValueError(
                r"must validate the regular expression /^[a-zA-Z][a-zA-Z0-9\-]{1,98}[a-zA-Z0-9]$/"
            )
        return value

    @validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("chat_prompt",):
            raise ValueError("must be one of enum values ('chat_prompt')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ChatPromptManifest:
        """Create an instance of ChatPromptManifest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item in self.messages:
                if _item:
                    _items.append(_item.to_dict())
            _dict["messages"] = _items
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of model_configuration
        if self.model_configuration:
            _dict["model_configuration"] = self.model_configuration.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ChatPromptManifest:
        """Create an instance of ChatPromptManifest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ChatPromptManifest.parse_obj(obj)

        _obj = ChatPromptManifest.parse_obj(
            {
                "name": obj.get("name"),
                "description": obj.get("description"),
                "metadata": obj.get("metadata"),
                "version_alias": obj.get("version_alias"),
                "ml_repo": obj.get("ml_repo"),
                "version": obj.get("version"),
                "type": obj.get("type")
                if obj.get("type") is not None
                else "chat_prompt",
                "messages": [
                    ChatPromptManifestMessagesInner.from_dict(_item)
                    for _item in obj.get("messages")
                ]
                if obj.get("messages") is not None
                else None,
                "variables": obj.get("variables"),
                "model_configuration": ModelConfiguration.from_dict(
                    obj.get("model_configuration")
                )
                if obj.get("model_configuration") is not None
                else None,
            }
        )
        return _obj
