# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import TYPE_CHECKING, Any, List, Optional, Union

from truefoundry.ml._autogen.client.models.blob_storage_reference import (
    BlobStorageReference,
)
from truefoundry.ml._autogen.client.models.content2_any_of_inner import (
    Content2AnyOfInner,
)
from truefoundry.pydantic_v1 import (
    BaseModel,
    Field,
    ValidationError,
    conlist,
    constr,
    validator,
)

CONTENT2_ANY_OF_SCHEMAS = ["BlobStorageReference", "List[Content2AnyOfInner]", "str"]


class Content2(BaseModel):
    """
    Content of the user message. can be a mix of text and images
    """

    # data type: str
    anyof_schema_1_validator: Optional[constr(strict=True)] = None
    # data type: BlobStorageReference
    anyof_schema_2_validator: Optional[BlobStorageReference] = None
    # data type: List[Content2AnyOfInner]
    anyof_schema_3_validator: Optional[conlist(Content2AnyOfInner)] = None
    if TYPE_CHECKING:
        actual_instance: Union[BlobStorageReference, List[Content2AnyOfInner], str]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(CONTENT2_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_anyof(cls, v):
        instance = Content2.construct()
        error_messages = []
        # validate data type: str
        try:
            instance.anyof_schema_1_validator = v
            return v
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # validate data type: BlobStorageReference
        if not isinstance(v, BlobStorageReference):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `BlobStorageReference`"
            )
        else:
            return v

        # validate data type: List[Content2AnyOfInner]
        try:
            instance.anyof_schema_3_validator = v
            return v
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if error_messages:
            # no match
            raise ValueError(
                "No match found when setting the actual_instance in Content2 with anyOf schemas: BlobStorageReference, List[Content2AnyOfInner], str. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Content2:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Content2:
        """Returns the object represented by the json string"""
        instance = Content2.construct()
        error_messages = []
        # deserialize data into str
        try:
            # validation
            instance.anyof_schema_1_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.anyof_schema_1_validator
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[BlobStorageReference] = None
        try:
            instance.actual_instance = BlobStorageReference.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into List[Content2AnyOfInner]
        try:
            # validation
            instance.anyof_schema_3_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.anyof_schema_3_validator
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into Content2 with anyOf schemas: BlobStorageReference, List[Content2AnyOfInner], str. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
