# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import TYPE_CHECKING, Any, List, Optional, Union

from truefoundry.ml._autogen.client.models.image_content_part import ImageContentPart
from truefoundry.ml._autogen.client.models.text_content_part import TextContentPart
from truefoundry.pydantic_v1 import (
    BaseModel,
    Field,
    ValidationError,
    validator,
)

CONTENT2ANYOFINNER_ANY_OF_SCHEMAS = ["ImageContentPart", "TextContentPart"]


class Content2AnyOfInner(BaseModel):
    """
    Content2AnyOfInner
    """

    # data type: TextContentPart
    anyof_schema_1_validator: Optional[TextContentPart] = None
    # data type: ImageContentPart
    anyof_schema_2_validator: Optional[ImageContentPart] = None
    if TYPE_CHECKING:
        actual_instance: Union[ImageContentPart, TextContentPart]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(CONTENT2ANYOFINNER_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_anyof(cls, v):
        instance = Content2AnyOfInner.construct()
        error_messages = []
        # validate data type: TextContentPart
        if not isinstance(v, TextContentPart):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `TextContentPart`"
            )
        else:
            return v

        # validate data type: ImageContentPart
        if not isinstance(v, ImageContentPart):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `ImageContentPart`"
            )
        else:
            return v

        if error_messages:
            # no match
            raise ValueError(
                "No match found when setting the actual_instance in Content2AnyOfInner with anyOf schemas: ImageContentPart, TextContentPart. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Content2AnyOfInner:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Content2AnyOfInner:
        """Returns the object represented by the json string"""
        instance = Content2AnyOfInner.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[TextContentPart] = None
        try:
            instance.actual_instance = TextContentPart.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[ImageContentPart] = None
        try:
            instance.actual_instance = ImageContentPart.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into Content2AnyOfInner with anyOf schemas: ImageContentPart, TextContentPart. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
