# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from truefoundry.ml._autogen.client.models.data_directory_manifest import (
    DataDirectoryManifest,
)
from truefoundry.ml._autogen.client.models.experiment_dto import ExperimentDto
from truefoundry.ml._autogen.client.models.subject import Subject
from truefoundry.pydantic_v1 import BaseModel, Field, StrictStr


class DatasetDto(BaseModel):
    """
    DatasetDto
    """

    id: StrictStr = Field(...)
    experiment_id: StrictStr = Field(...)
    name: StrictStr = Field(...)
    fqn: StrictStr = Field(...)
    description: Optional[StrictStr] = None
    created_by: Optional[StrictStr] = None
    created_by_subject: Subject = Field(...)
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    storage_root: Optional[StrictStr] = None
    dataset_metadata: Optional[Dict[str, Any]] = None
    manifest: DataDirectoryManifest = Field(...)
    usage_code_snippet: Optional[StrictStr] = None
    experiment: Optional[ExperimentDto] = None
    __properties = [
        "id",
        "experiment_id",
        "name",
        "fqn",
        "description",
        "created_by",
        "created_by_subject",
        "created_at",
        "updated_at",
        "storage_root",
        "dataset_metadata",
        "manifest",
        "usage_code_snippet",
        "experiment",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DatasetDto:
        """Create an instance of DatasetDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of created_by_subject
        if self.created_by_subject:
            _dict["created_by_subject"] = self.created_by_subject.to_dict()
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of manifest
        if self.manifest:
            _dict["manifest"] = self.manifest.to_dict()
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of experiment
        if self.experiment:
            _dict["experiment"] = self.experiment.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DatasetDto:
        """Create an instance of DatasetDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DatasetDto.parse_obj(obj)

        _obj = DatasetDto.parse_obj(
            {
                "id": obj.get("id"),
                "experiment_id": obj.get("experiment_id"),
                "name": obj.get("name"),
                "fqn": obj.get("fqn"),
                "description": obj.get("description"),
                "created_by": obj.get("created_by"),
                "created_by_subject": Subject.from_dict(obj.get("created_by_subject"))
                if obj.get("created_by_subject") is not None
                else None,
                "created_at": obj.get("created_at"),
                "updated_at": obj.get("updated_at"),
                "storage_root": obj.get("storage_root"),
                "dataset_metadata": obj.get("dataset_metadata"),
                "manifest": DataDirectoryManifest.from_dict(obj.get("manifest"))
                if obj.get("manifest") is not None
                else None,
                "usage_code_snippet": obj.get("usage_code_snippet"),
                "experiment": ExperimentDto.from_dict(obj.get("experiment"))
                if obj.get("experiment") is not None
                else None,
            }
        )
        return _obj
