# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401

from truefoundry.ml._autogen.client.models.artifact_path import ArtifactPath
from truefoundry.pydantic_v1 import BaseModel, Field, StrictStr, conlist, validator


class LocalArtifactSource(BaseModel):
    """
    LocalArtifactSource
    """

    type: StrictStr = Field(default=..., description="Type of the source")
    paths: conlist(ArtifactPath) = Field(
        default=...,
        description="Array of ArtifactPath objects representing the source and destination paths",
    )
    __properties = ["type", "paths"]

    @validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ("local",):
            raise ValueError("must be one of enum values ('local')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LocalArtifactSource:
        """Create an instance of LocalArtifactSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of each item in paths (list)
        _items = []
        if self.paths:
            for _item in self.paths:
                if _item:
                    _items.append(_item.to_dict())
            _dict["paths"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LocalArtifactSource:
        """Create an instance of LocalArtifactSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LocalArtifactSource.parse_obj(obj)

        _obj = LocalArtifactSource.parse_obj(
            {
                "type": obj.get("type"),
                "paths": [ArtifactPath.from_dict(_item) for _item in obj.get("paths")]
                if obj.get("paths") is not None
                else None,
            }
        )
        return _obj
