# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import TYPE_CHECKING, Any, List, Optional, Union

from truefoundry.ml._autogen.client.models.external_blob_storage_source import (
    ExternalBlobStorageSource,
)
from truefoundry.ml._autogen.client.models.local_artifact_source import (
    LocalArtifactSource,
)
from truefoundry.ml._autogen.client.models.true_foundry_managed_source import (
    TrueFoundryManagedSource,
)
from truefoundry.pydantic_v1 import (
    BaseModel,
    Field,
    ValidationError,
    validator,
)

SOURCE_ANY_OF_SCHEMAS = [
    "ExternalBlobStorageSource",
    "LocalArtifactSource",
    "TrueFoundryManagedSource",
]


class Source(BaseModel):
    """
    Source
    """

    # data type: TrueFoundryManagedSource
    anyof_schema_1_validator: Optional[TrueFoundryManagedSource] = None
    # data type: ExternalBlobStorageSource
    anyof_schema_2_validator: Optional[ExternalBlobStorageSource] = None
    # data type: LocalArtifactSource
    anyof_schema_3_validator: Optional[LocalArtifactSource] = None
    if TYPE_CHECKING:
        actual_instance: Union[
            ExternalBlobStorageSource, LocalArtifactSource, TrueFoundryManagedSource
        ]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(SOURCE_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_anyof(cls, v):
        instance = Source.construct()
        error_messages = []
        # validate data type: TrueFoundryManagedSource
        if not isinstance(v, TrueFoundryManagedSource):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `TrueFoundryManagedSource`"
            )
        else:
            return v

        # validate data type: ExternalBlobStorageSource
        if not isinstance(v, ExternalBlobStorageSource):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `ExternalBlobStorageSource`"
            )
        else:
            return v

        # validate data type: LocalArtifactSource
        if not isinstance(v, LocalArtifactSource):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `LocalArtifactSource`"
            )
        else:
            return v

        if error_messages:
            # no match
            raise ValueError(
                "No match found when setting the actual_instance in Source with anyOf schemas: ExternalBlobStorageSource, LocalArtifactSource, TrueFoundryManagedSource. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Source:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Source:
        """Returns the object represented by the json string"""
        instance = Source.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[TrueFoundryManagedSource] = None
        try:
            instance.actual_instance = TrueFoundryManagedSource.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[ExternalBlobStorageSource] = None
        try:
            instance.actual_instance = ExternalBlobStorageSource.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[LocalArtifactSource] = None
        try:
            instance.actual_instance = LocalArtifactSource.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into Source with anyOf schemas: ExternalBlobStorageSource, LocalArtifactSource, TrueFoundryManagedSource. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
