# coding: utf-8

"""
TrueFoundry ML API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from truefoundry.ml._autogen.client.models.xg_boost_model_schema import (
    XGBoostModelSchema,
)
from truefoundry.ml._autogen.client.models.xg_boost_serialization_format import (
    XGBoostSerializationFormat,
)
from truefoundry.pydantic_v1 import BaseModel, Field, StrictStr, validator


class XGBoostFramework(BaseModel):
    """
    XGBoostFramework
    """

    type: StrictStr = Field(default=..., description="Type of the framework")
    serialization_format: Optional[XGBoostSerializationFormat] = None
    model_filepath: Optional[StrictStr] = Field(
        default=None,
        description="Relative path to the model file in the model version contents",
    )
    model_schema: Optional[XGBoostModelSchema] = None
    __properties = ["type", "serialization_format", "model_filepath", "model_schema"]

    @validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ("xgboost",):
            raise ValueError("must be one of enum values ('xgboost')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> XGBoostFramework:
        """Create an instance of XGBoostFramework from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from truefoundry.pydantic_v1 by calling `to_dict()` of model_schema
        if self.model_schema:
            _dict["model_schema"] = self.model_schema.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> XGBoostFramework:
        """Create an instance of XGBoostFramework from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return XGBoostFramework.parse_obj(obj)

        _obj = XGBoostFramework.parse_obj(
            {
                "type": obj.get("type"),
                "serialization_format": obj.get("serialization_format"),
                "model_filepath": obj.get("model_filepath"),
                "model_schema": XGBoostModelSchema.from_dict(obj.get("model_schema"))
                if obj.get("model_schema") is not None
                else None,
            }
        )
        return _obj
